// Code generated by go-bindata.
// sources:
// migrations/1_init_schema.up.sql
// DO NOT EDIT!

package migrations

import (
	"fmt"
	"io/ioutil"
	"os"
	"path/filepath"
	"strings"
	"time"
)
type asset struct {
	bytes []byte
	info  os.FileInfo
}

type bindataFileInfo struct {
	name    string
	size    int64
	mode    os.FileMode
	modTime time.Time
}

func (fi bindataFileInfo) Name() string {
	return fi.name
}
func (fi bindataFileInfo) Size() int64 {
	return fi.size
}
func (fi bindataFileInfo) Mode() os.FileMode {
	return fi.mode
}
func (fi bindataFileInfo) ModTime() time.Time {
	return fi.modTime
}
func (fi bindataFileInfo) IsDir() bool {
	return false
}
func (fi bindataFileInfo) Sys() interface{} {
	return nil
}

var __1_init_schemaUpSql = []byte(`
CREATE TABLE tasks (
  id TEXT PRIMARY KEY,
  method TEXT NOT NULL,
  -- max_failures INTEGER,
  created_at DATETIME,
  not_before DATETIME,
  downstream_task_id TEXT,
  result_id TEXT
);

CREATE TABLE task_args (
  task_id TEXT,
  arg_type INTEGER,
  value_json BLOB,
  ref_task_id TEXT,
  has_result INTEGER DEFAULT 0,
  FOREIGN KEY(task_id) REFERENCES tasks(id)
);

CREATE INDEX idx_task_args_task_id ON task_args(task_id);
CREATE INDEX idx_task_args_ref_task_id ON task_args(ref_task_id);

-- The tables for various task states.
CREATE TABLE scheduled (
  task_id TEXT PRIMARY KEY,
  schedule_time DATETIME NOT NULL,
  FOREIGN KEY(task_id) REFERENCES tasks(id)
);

CREATE TABLE running (
  task_id TEXT PRIMARY KEY,
  started_at DATETIME NOT NULL,
  pinged_at DATETIME,
  url TEXT,
  FOREIGN KEY(task_id) REFERENCES tasks(id)
);

CREATE TABLE pending (
  task_id TEXT PRIMARY KEY,
  FOREIGN KEY(task_id) REFERENCES tasks(id)
);

CREATE TABLE done (
  task_id TEXT PRIMARY KEY,
  state INTEGER,
  completed_at DATETIME,
  FOREIGN KEY(task_id) REFERENCES tasks(id)
);

-- A queue of task state transitions that need to be processed.
CREATE TABLE pending_transitions (
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  task_id TEXT,
  result_status INTEGER,
  result_data BLOB,
  pending_since DATETIME NOT NULL
);

-- Tables for associated data.
CREATE TABLE results (
  result_id TEXT PRIMARY KEY,
  task_id TEXT,
  value BLOB
);

CREATE INDEX idx_results_task_id ON results(task_id);

CREATE TABLE logs (
  task_id TEXT,
  data BLOB,
  timestamp DATETIME NOT NULL
);

CREATE INDEX idx_logs_task_id ON logs(task_id);

CREATE TABLE execution_log (
  task_id INTEGER NOT NULL,
  host TEXT,
  started_at DATETIME,
  completed_at DATETIME,
  error_message TEXT,
  is_error INTEGER,
  is_retriable INTEGER
);
`)

func _1_init_schemaUpSqlBytes() ([]byte, error) {
	return __1_init_schemaUpSql, nil
}

func _1_init_schemaUpSql() (*asset, error) {
	bytes, err := _1_init_schemaUpSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{name: "1_init_schema.up.sql", size: 1800, mode: os.FileMode(420), modTime: time.Unix(1670239659, 0)}
	a := &asset{bytes: bytes, info: info}
	return a, nil
}

// Asset loads and returns the asset for the given name.
// It returns an error if the asset could not be found or
// could not be loaded.
func Asset(name string) ([]byte, error) {
	cannonicalName := strings.Replace(name, "\\", "/", -1)
	if f, ok := _bindata[cannonicalName]; ok {
		a, err := f()
		if err != nil {
			return nil, fmt.Errorf("Asset %s can't read by error: %v", name, err)
		}
		return a.bytes, nil
	}
	return nil, fmt.Errorf("Asset %s not found", name)
}

// MustAsset is like Asset but panics when Asset would return an error.
// It simplifies safe initialization of global variables.
func MustAsset(name string) []byte {
	a, err := Asset(name)
	if err != nil {
		panic("asset: Asset(" + name + "): " + err.Error())
	}

	return a
}

// AssetInfo loads and returns the asset info for the given name.
// It returns an error if the asset could not be found or
// could not be loaded.
func AssetInfo(name string) (os.FileInfo, error) {
	cannonicalName := strings.Replace(name, "\\", "/", -1)
	if f, ok := _bindata[cannonicalName]; ok {
		a, err := f()
		if err != nil {
			return nil, fmt.Errorf("AssetInfo %s can't read by error: %v", name, err)
		}
		return a.info, nil
	}
	return nil, fmt.Errorf("AssetInfo %s not found", name)
}

// AssetNames returns the names of the assets.
func AssetNames() []string {
	names := make([]string, 0, len(_bindata))
	for name := range _bindata {
		names = append(names, name)
	}
	return names
}

// _bindata is a table, holding each asset generator, mapped to its name.
var _bindata = map[string]func() (*asset, error){
	"1_init_schema.up.sql": _1_init_schemaUpSql,
}

// AssetDir returns the file names below a certain
// directory embedded in the file by go-bindata.
// For example if you run go-bindata on data/... and data contains the
// following hierarchy:
//     data/
//       foo.txt
//       img/
//         a.png
//         b.png
// then AssetDir("data") would return []string{"foo.txt", "img"}
// AssetDir("data/img") would return []string{"a.png", "b.png"}
// AssetDir("foo.txt") and AssetDir("notexist") would return an error
// AssetDir("") will return []string{"data"}.
func AssetDir(name string) ([]string, error) {
	node := _bintree
	if len(name) != 0 {
		cannonicalName := strings.Replace(name, "\\", "/", -1)
		pathList := strings.Split(cannonicalName, "/")
		for _, p := range pathList {
			node = node.Children[p]
			if node == nil {
				return nil, fmt.Errorf("Asset %s not found", name)
			}
		}
	}
	if node.Func != nil {
		return nil, fmt.Errorf("Asset %s not found", name)
	}
	rv := make([]string, 0, len(node.Children))
	for childName := range node.Children {
		rv = append(rv, childName)
	}
	return rv, nil
}

type bintree struct {
	Func     func() (*asset, error)
	Children map[string]*bintree
}
var _bintree = &bintree{nil, map[string]*bintree{
	"1_init_schema.up.sql": &bintree{_1_init_schemaUpSql, map[string]*bintree{}},
}}

// RestoreAsset restores an asset under the given directory
func RestoreAsset(dir, name string) error {
	data, err := Asset(name)
	if err != nil {
		return err
	}
	info, err := AssetInfo(name)
	if err != nil {
		return err
	}
	err = os.MkdirAll(_filePath(dir, filepath.Dir(name)), os.FileMode(0755))
	if err != nil {
		return err
	}
	err = ioutil.WriteFile(_filePath(dir, name), data, info.Mode())
	if err != nil {
		return err
	}
	err = os.Chtimes(_filePath(dir, name), info.ModTime(), info.ModTime())
	if err != nil {
		return err
	}
	return nil
}

// RestoreAssets restores an asset under the given directory recursively
func RestoreAssets(dir, name string) error {
	children, err := AssetDir(name)
	// File
	if err != nil {
		return RestoreAsset(dir, name)
	}
	// Dir
	for _, child := range children {
		err = RestoreAssets(dir, filepath.Join(name, child))
		if err != nil {
			return err
		}
	}
	return nil
}

func _filePath(dir, name string) string {
	cannonicalName := strings.Replace(name, "\\", "/", -1)
	return filepath.Join(append([]string{dir}, strings.Split(cannonicalName, "/")...)...)
}

